var fakedevice = {
	name: "fakephone",
	platform: "fakeplatform",
	version: "alphafake 0.0.1",
	uuid: "4711-0815"
}

var Util = {
	userSettings: {},
	storageKey: "bujuSettings",	
	getParameterByName: function(name) {
		var match = RegExp('[?&]' + name + '=([^&]*)').exec(window.location.search);
		return match && decodeURIComponent(match[1].replace(/\+/g, ' '));
	},
	storeSettings: function(){
		amplify.store(Util.storageKey, Util.userSettings);
	},
	loadSettings: function(){	
		if(amplify.store(Util.storageKey))
			Util.userSettings = amplify.store(Util.storageKey);
	},
	getUserSetting: function(settingname){
		var getUserSettingRetVal = null;
		if(Util.userSettings){
			$.each(Util.userSettings, function(key,val){				
				if(key==settingname)
					getUserSettingRetVal = val;
			})					
		}
		return getUserSettingRetVal;
	},
	setUserSetting: function(settingname, settingvalue){
		Util.userSettings[settingname] = settingvalue;			
		Util.storeSettings();
		/*
		if(Util.userSettings){
			$.each(Util.userSettings, function(key,val){
				if(val.name==settingname)
					val.value = settingvalue;
			})					
			Util.storeSettings();
		}
		*/
	},
	convertResultsALT: function(resultset) {
		var results = [];
		for(var i=0,len=resultset.rows.length;i<len;i++) {
			var row = resultset.rows.item(i);
			var result = {};
			for(var key in row) {
				result[key] = row[key];
			}
			results.push(result);
		}
		return results;
	},
	convertResults: function(resultset,tbl_name) {
		var results = [];
		for(var i=0,len=resultset.rows.length;i<len;i++) {
			var row = resultset.rows.item(i);
			var _fields= [];
			var _values = [];
			for(col in row){
				_fields.push(col);
				_values.push('"' + row[col] + '"');
			}
			results.push("INSERT INTO " + tbl_name + "(" + _fields.join(",") + ") VALUES (" + _values.join(",") + ")");
		}
		return results;
	},
	areYouSure: function(text1, text2, button, callback) {
	  $("#sure .sure-1").text(text1);
	  $("#sure .sure-2").text(text2);
	  $("#sure .sure-do").text(button).on("click.sure", function() {
		callback();
		$(this).off("click.sure");
	  });
	}	

}

var nonRiege = new Array({
	riege: 0,
	riegeTitel: "für alle Teilnehmer",
	nonRiege: true
})


var buju = {
	//serviceUrl: "http://192.168.0.207/bjs_service/index.php",
	//serviceUrl: "http://www.webbutler.info/testdrive/bj-spiele_layout/cgi-bin/appService.php",
	serviceUrl: "https://www.bundesjugendspiele.de/cgi-bin/appService.php",
	loginSuccess: false,
	loginToken: "",
	userEmail: "NoMaIl",
	userLogin: "",
	userId: 0,
	debugConsoleDataEnable: false,
	debugConsoleData: [],	
	init: function(){
		//fastclick
		$.mobile.defaultPageTransition = "none";
		FastClick.attach(document.body);
	
        $( document ).on( "pagecreate", function() {
            $( "body > [data-role='panel']" ).panel();
            $( "body > [data-role='panel'] [data-role='listview']" ).listview();
        });	
        $( document ).one( "pageshow", function() {
            $( "body > [data-role='header']" ).toolbar();
            $( "body > [data-role='header'] [data-role='navbar']" ).navbar();
        });
		buju.pageLogic();
		buju.restoreLoginInfo();	
	},
	storeLoginInfo: function(){
		buju.debugInfo("storeLoginInfo");
		buju.debugInfo("loginSuccess" + buju.loginSuccess);
		buju.debugInfo("loginToken" + buju.loginToken);
		buju.debugInfo("userEmail" + buju.userEmail);
		buju.debugInfo("userLogin" + buju.userLogin);
		Util.setUserSetting("loginSuccess", buju.loginSuccess);
		Util.setUserSetting("loginToken", buju.loginToken);
		Util.setUserSetting("userEmail", buju.userEmail);
		Util.setUserSetting("userId", buju.userId);	
		Util.setUserSetting("userLogin", buju.userLogin);	
	},
	restoreLoginInfo: function(){
		Util.loadSettings();
		buju.debugInfo("restoreLoginInfo");
		if(Util.getUserSetting("loginSuccess")==true && Util.getUserSetting("loginToken")!=""){
			buju.debugInfo("restoreLoginInfoSuccess");
			buju.loginSuccess=Util.getUserSetting("loginSuccess");
			buju.loginToken=Util.getUserSetting("loginToken");
			buju.userEmail=Util.getUserSetting("userEmail");
			buju.userId=Util.getUserSetting("userId");
			buju.userLogin=Util.getUserSetting("userLogin");
			BUJUSYNCDATA.updateSyncInfo();			
			buju.refreshLoginView();
		}
	},
	currentRS: {
		exists: false,
		dataIndexVeranstaltungen: -1,
		dataVeranstaltungen: [],
		dataIndexTeilnehmerlisten: -1,
		dataTeilnehmerlisten: [],
		getTypId: function(){
			return buju.currentRS.dataVeranstaltungen[buju.currentRS.dataIndexVeranstaltungen].veranstaltungstyp;
		},
		getSportartId: function(){
			return buju.currentRS.dataVeranstaltungen[buju.currentRS.dataIndexVeranstaltungen].sportart;
		},
		getSportartTxt: function(){
			return buju.currentRS.dataVeranstaltungen[buju.currentRS.dataIndexVeranstaltungen].sportart_txt;
		},		
		getTitelVeranstaltung: function(){
			return buju.currentRS.dataVeranstaltungen[buju.currentRS.dataIndexVeranstaltungen].titel;
		},
		getTypTxt: function(){
			return buju.currentRS.dataVeranstaltungen[buju.currentRS.dataIndexVeranstaltungen].veranstaltungstyp_txt;
		},		
		getTnlId: function(){
			return buju.currentRS.dataTeilnehmerlisten[buju.currentRS.dataIndexTeilnehmerlisten].tnl_id;
		},
		isRiege: function(){
			if(buju.currentRS.dataTeilnehmerlisten[buju.currentRS.dataIndexTeilnehmerlisten].riege!=0)
				return true;
			else
				return false;
		},
		getTitelTeilnehmerliste: function(){
			return buju.currentRS.dataTeilnehmerlisten[buju.currentRS.dataIndexTeilnehmerlisten].bezeichnung;
		},
		getLeiterTeilnehmerliste: function(){
			return buju.currentRS.dataTeilnehmerlisten[buju.currentRS.dataIndexTeilnehmerlisten].leiter;
		}
	},
	contentBlock: {
		collapsibleVeranstaltungs: function(callBack){
			var contentStr = new Array();			
			contentStr.push("<div data-role=\"collapsible\">");
			contentStr.push("<h4>Veranstaltungsdetails</h4>");
			contentStr.push("<p><b>Titel der Veranstaltung:</b> ");
			contentStr.push(buju.currentRS.getTitelVeranstaltung());
			contentStr.push("</p>");
			contentStr.push("<p><b>Typ der Veranstaltung:</b> ");
			contentStr.push(buju.currentRS.getTypTxt());
			contentStr.push("</p>");			
			if (buju.currentRS.getTypId()!=3){
				contentStr.push("<p><b>Sportart:</b> ");
				contentStr.push(buju.currentRS.getSportartTxt());
				contentStr.push("</p>");						
			}
			contentStr.push("</div>");
			callBack(contentStr.join(""));
		},
		collapsibleTeilnehmerliste: function(callBack){
			var contentStr = new Array();			
			contentStr.push("<div data-role=\"collapsible\">");
			contentStr.push("<h4>Teilnehmerlistendetails</h4>");
			contentStr.push("<p><b>Titel der Teilnehmerliste:</b> ");
			contentStr.push(buju.currentRS.getTitelTeilnehmerliste());
			contentStr.push("</p>");
			contentStr.push("<p><b>Leiter:</b> ");
			contentStr.push(buju.currentRS.getLeiterTeilnehmerliste());
			contentStr.push("</p>");			
			contentStr.push("</div>");
			callBack(contentStr.join(""));		
		},
		listDisziplinen: function(riegeArr,callBack){
			var contentStr = new Array();			
			if(riegeArr){				
				var lc=0;
				$.each(riegeArr, function(key,data){					
					if(data.riege || data.nonRiege){						
						var sql = "";					
						if(buju.currentRS.getTypId()==3){ //Mehrkampf										
							sql = "SELECT `disziplinen`.`disziplin_id`,`disziplin`,`wk_versuche`,`leistungen_vollstaendig`.`id` AS `leistung_vollstaendig` FROM `disziplinen` LEFT JOIN `leistungen_vollstaendig` ON (`disziplinen`.`disziplin_id`=`leistungen_vollstaendig`.`disziplin_id` AND `leistungen_vollstaendig`.`tnl_id`="+buju.currentRS.getTnlId()+" AND `leistungen_vollstaendig`.`riege`="+data.riege+" AND `leistungen_vollstaendig`.`markAsDel`=0) WHERE `disziplinen`.`veranstaltungstyp_id`="+buju.currentRS.getTypId()+" ORDER BY 1";
						} else {
							//sql = "SELECT `disziplinen`.`disziplin_id`,`disziplin`,`wk_versuche`,`leistungen_vollstaendig`.`cid` AS `leistung_vollstaendig` FROM `disziplinen` LEFT JOIN `leistungen_vollstaendig` ON (`disziplinen`.`disziplin_id`=`leistungen_vollstaendig`.`disziplin_id` AND `leistungen_vollstaendig`.`tnl_id`="+buju.currentRS.getTnlId()+" AND `leistungen_vollstaendig`.`riege`="+data.riege+" AND `leistungen_vollstaendig`.`markAsDel`=0) WHERE `disziplinen`.`veranstaltungstyp_id`="+buju.currentRS.getTypId()+" And `disziplinen`.`sportart_id`="+buju.currentRS.getSportartId()+" ORDER BY 1";
							//vanessa hat einen fehler gefunden (wk schwimmen)... abfrage anpassen
							sql = "SELECT DISTINCT `disziplinen`.`disziplin_id`,`disziplin`,`wk_versuche`,`leistungen_vollstaendig`.`cid` AS `leistung_vollstaendig` FROM `disziplinen` LEFT JOIN `leistungen_vollstaendig` ON (`disziplinen`.`disziplin_id`=`leistungen_vollstaendig`.`disziplin_id` AND `leistungen_vollstaendig`.`tnl_id`="+buju.currentRS.getTnlId()+" AND `leistungen_vollstaendig`.`riege`="+data.riege+" AND `leistungen_vollstaendig`.`markAsDel`=0) INNER JOIN `uebauswahl` ON `disziplinen`.`disziplin_id`=`uebauswahl`.`disziplin_id` AND `uebauswahl`.`tnl_id`="+buju.currentRS.getTnlId()+" INNER JOIN `teilnehmerlisten_v_schueler` ON `teilnehmerlisten_v_schueler`.`tnl_v_schueler_id`=`uebauswahl`.`tnl_v_schueler_id` AND `teilnehmerlisten_v_schueler`.`riege`="+data.riege+" WHERE `disziplinen`.`veranstaltungstyp_id`="+buju.currentRS.getTypId()+" And `disziplinen`.`sportart_id`="+buju.currentRS.getSportartId()+" ORDER BY 1";
												
						}
							
						
						DBSYNC._selectSql(sql, "", function(elems){
							//contentStr.push("<p>"+sql+"</p>");
							contentStr.push("<div class=\"ui-corner-all custom-corners\">"); //open_outer
							
							contentStr.push("<div class=\"ui-bar ui-bar-a\">");
							contentStr.push("<h3>");
							if (data.riegeTitel){
								contentStr.push(data.riegeTitel);
							} else {							
								contentStr.push("Riege ");
								contentStr.push(data.riege);								
							}
							contentStr.push("</h3>");						
							contentStr.push("</div>");						
						
							var lc1In=0;
							var cssClassCompleted="";
							$.each(elems, function(key1In, data1In){
								if (lc1In==0)
									contentStr.push("<div class=\"ui-body ui-body-a\"><p>"); //open_inner
							
								//unterscheidung vollstaendig oder nicht fehlt hier noch...	
								if(data1In.leistung_vollstaendig)
									cssClassCompleted=" leistungCompleted";
								else
									cssClassCompleted="";
								
								
								if(data.nonRiege){
									contentStr.push("<a href=\"workinput.html?disziplin_id=");
									contentStr.push(data1In.disziplin_id);
									contentStr.push("\" class=\"ui-btn ui-btn-inline"+cssClassCompleted+"\">");
								} else {
									contentStr.push("<a href=\"workinput.html?riege=");
									contentStr.push(data.riege);
									contentStr.push("&disziplin_id=");
									contentStr.push(data1In.disziplin_id);
									contentStr.push("\" class=\"ui-btn ui-btn-inline"+cssClassCompleted+"\">");
								}
								
								contentStr.push(data1In.disziplin);
								contentStr.push("</a>");
								
								//Konstrukt um Callback im letzten Durchlauf aufzurufen								
								lc1In++;			
								if(elems.length==lc1In){
									lc++;
									contentStr.push("</p></div>"); //close_inner									
									contentStr.push("</div>"); //close_outer									
									if(riegeArr.length==lc)									
										callBack(contentStr.join(""));
								}
							});													
						});											
					}
				})						
			} 		
		}
	},
	doLogin: function(login, password){	
		$.mobile.loading( "show" );	
		var postdata = new Array()
		postdata.push({ 'name': 'aktion', 'value':'doLogin'});
		postdata.push({ 'name': 'login', 'value': login});
		postdata.push({ 'name': 'password', 'value': CryptoJS.MD5(password)});					
		postdata.push({ 'name': 'device_name', 'value': device.name});
		postdata.push({ 'name': 'device_platform', 'value': device.platform});
		postdata.push({ 'name': 'device_uuid', 'value': fakedevice.uuid});
		postdata.push({ 'name': 'device_version', 'value': fakedevice.version});
		
					
		$.post(buju.serviceUrl, postdata, function(data){	
			buju.loginSuccess = data.login_status.login_success;
			buju.loginToken = data.login_status.session_id;
			buju.userEmail = data.login_status.email;
			buju.userId = data.login_status.userId;
			buju.userLogin = data.login_status.login;
			BUJUSYNCDATA.updateSyncInfo();
			buju.storeLoginInfo();
			buju.refreshLoginView();			
		});
	},
	doLogout: function(){
		$.mobile.loading( "show" );
		buju.loginSuccess = false;
		buju.loginToken = "";
		buju.userEmail = "NoMaIl",
		buju.userLogin = "",
		buju.userId = 0;
		BUJUSYNCDATA.updateSyncInfo();
		buju.storeLoginInfo();
		
		buju.useDB(function(){
			BUJUSYNCDATA.clearDb(function(){
				//Login Seite initial neu laden	
				BUJUSYNCDATA.database = null;
				$.mobile.changePage("login.html",{reloadPage: true});	
				$("#login-btn").addClass("nologin");
				$("#menu_work").addClass("ui-disabled");
				$.mobile.loading( "hide" );
			});
		});				
	},
	refreshLoginView: function(){	
		if(buju.loginSuccess){		
			$("#login-btn").removeClass("nologin");
			$("#menu_work").removeClass("ui-disabled");
			$("#loginInfo",$.mobile.activePage).hide();
			console.log("dialog1");
			Util.areYouSure("Sind Sie sicher?", "Wenn Sie sich abmelden, werden alle Account bezogenen Daten und Eingaben von dem Gerät gelöscht.", "Abmelden", function() {
				// user has confirmed, do stuff
				buju.doLogout();
			})			
			console.log("dialog2");
			$("#loginInfo",$.mobile.activePage).html("<p>Erfolgreich angemeldet als "+buju.userLogin+".</p><p><a href=\"#sure\" class=\"ui-btn\" data-rel=\"dialog\">Abmelden</a></p>").trigger("create");
			console.log("dialog3");
			$("#loginInfo",$.mobile.activePage).show(200);
			$("#SyncInfo",$.mobile.activePage).show(200);
			$.mobile.loading( "hide" );
		} else {
			$("#login-btn").addClass("nologin");
			$("#menu_work").addClass("ui-disabled");			
			$.mobile.loading( "hide" );
			$("#username",$.mobile.activePage).val("");
			$("#password",$.mobile.activePage).val("");
			$("#loginFormCallback",$.mobile.activePage).html("<p>Anmelden nicht möglich</p>").show().hide(5000);
			$("#SyncInfo").hide();
		}
		buju.pageCheckMenuState();
	},
	pageCheckMenuState: function(){
		/*
		Angedacht:
		Buttons im Menu in Abhängigkeit angemeldet/nicht angemeldet,
		Synchronisiert oder nicht anzeigen oder aber ausblenden.
		*/
	},
	pageLogic: function(){
		buju.pageCheckMenuState();
		$(document)
			.on('pageshow', '#loginPage', function(){
				if(buju.loginSuccess){
					$.mobile.loading( "show" );
					buju.refreshLoginView();
				} else {
					$("#loginInfo",$.mobile.activePage).show(200);
				}
								
				$("#loginForm #submitButton",$.mobile.activePage).click(function(){					
					if($("#loginForm #username").val() && $("#loginForm #password").val() ){						
						buju.doLogin($("#loginForm #username").val(), $("#loginForm #password").val());
					}
					
				})
				
				$('.chart').easyPieChart({
					size: 150,
					barColor: '#E4002B',
					lineWidth: 6,
					onStep: function(from, to, percent) {
						$(this.el).find('.percent').text(Math.round(percent));
					}
				});
				var chart = window.chart = $('.chart').data('easyPieChart');												
								
				$("#syncBtn",$.mobile.activePage).click(function(){
					//Sync...
					chart.update(0);
					buju.doSync();				
				})												
			})
			.on('pageshow', '#workPage', function(){			
				/*Veranstaltungen auflisten*/
				buju.useDB(function(){
					vsql = "SELECT id, titel, veranstaltungen.veranstaltungstyp, veranstaltungstypen.veranstaltungstyp AS veranstaltungstyp_txt, veranstaltungen.sportart, sportarten.sportart AS sportart_txt, ts FROM (veranstaltungen LEFT JOIN veranstaltungstypen ON veranstaltungen.veranstaltungstyp = veranstaltungstypen.veranstaltungstyp_id) LEFT JOIN sportarten ON veranstaltungen.sportart = sportarten.sportart_id WHERE lehrer_id="+buju.userId+" ORDER BY 7 DESC"
													
					DBSYNC._selectSql(vsql, "", function(elems){
						buju.currentRS.dataVeranstaltungen = elems;
						var output="";
						var listIndex=0;
						$.each(elems,function(key,data){							        
							output += '<li><a href="worktn.html?veranstaltungs_id='+data.id+'&listindex='+listIndex+'" >';
							output += '<h2>'+data.titel+ '</h2>';
							output += '<p>'+data.veranstaltungstyp_txt+'</p>';
							if (data.veranstaltungstyp!=3)
								output += '<p>'+data.sportart_txt+'</p>';
							output += '<p>Datum: '+data.ts+'</p>';
							output += '</a></li>';                						
							listIndex++;
						})
						$('#listviewVeranstaltungen',$.mobile.activePage).html(output).listview("refresh");
					})			
				})										
			})
			.on('pageshow', '#worktnPage', function(){			
				/*Teilnehmerlisten auflisten*/
				buju.useDB(function(){
					var veranstaltungs_id = Util.getParameterByName('veranstaltungs_id');
					buju.currentRS.dataIndexVeranstaltungen = Util.getParameterByName('listindex');

					//++ Veranstaltungsdetails ausgeben ++					
					buju.contentBlock.collapsibleVeranstaltungs(function(str){$("#veranstaltungsdetails",$.mobile.activePage).html(str).trigger("create")});
					//++ Veranstaltungsdetails ausgeben bis hier ++
					
					tnsql = "SELECT tnl_id, bezeichnung, leiter, ts, riege FROM teilnehmerlisten WHERE veranstaltungs_id=" +veranstaltungs_id+ " ORDER BY 2"
					DBSYNC._selectSql(tnsql, "", function(elems){
						buju.currentRS.dataTeilnehmerlisten = elems;
						var output="";
						var listindex=0;
						$.each(elems,function(key,data){							        
							output += '<li><a href="worktnselect.html?veranstaltungs_id='+veranstaltungs_id+'&tnl_id='+data.tnl_id+'&listindex='+listindex+'">'
							output += '<h2>'+data.bezeichnung+'</h2>';
							if(data.leiter)
								output += '<p>Leiter: '+data.leiter+'</p>';
							if(data.ts)
							output += '<p>Datum: '+data.ts+'</p>';
							output += '</a></li>';                						
							listindex++;
						})
						$('#listviewTeilnehmerlisten',$.mobile.activePage).html(output).listview("refresh");
					})
				})										
			})
			.on('pageshow', '#worktnselectPage', function(){
				/*Disziplinen auflisten*/
				buju.useDB(function(){
					var veranstaltungs_id = Util.getParameterByName('veranstaltungs_id');
					var tnl_id = Util.getParameterByName('tnl_id');
					buju.currentRS.dataIndexTeilnehmerlisten = Util.getParameterByName('listindex');
					
					//++ Veranstaltungsdetails ausgeben ++					
					buju.contentBlock.collapsibleVeranstaltungs(function(str){$("#veranstaltungsdetails",$.mobile.activePage).html(str).trigger("create")});
					//++ Veranstaltungsdetails ausgeben bis hier ++
					//++ Teilnehmerlistendetails ausgeben ++					
					buju.contentBlock.collapsibleTeilnehmerliste(function(str){$("#teilnehmerlistedetails",$.mobile.activePage).html(str).trigger("create")});
					//++ Teilnehmerlistendetails ausgeben bis hier ++
																			
					if(buju.currentRS.isRiege()){
						// mit Riegeneinteilung											
						DBSYNC._selectSql("SELECT DISTINCT riege FROM teilnehmerlisten_v_schueler WHERE tnl_id=" + tnl_id, "", function(elems){
							//Riege xy
							if(elems)
								buju.contentBlock.listDisziplinen(elems, function(str){$("#worktncontent").append(str)});						
							else
								buju.contentBlock.listDisziplinen(nonRiege, function(str){$("#worktncontent").append(str)});							
						})
					} else {
						buju.contentBlock.listDisziplinen(nonRiege, function(str){$("#worktncontent").append(str)});
					}																					
				})										
			})

			.on('pageshow', '#workinput', function(){
				/*Ansicht Leistungen eintragen*/
				buju.useDB(function(){
					var riege = Util.getParameterByName('riege');
					var disziplin_id = Util.getParameterByName('disziplin_id');
					var tnl_id = buju.currentRS.getTnlId();

					firstsql = "SELECT cid,id FROM leistungen_vollstaendig WHERE tnl_id="+tnl_id+" AND disziplin_id="+disziplin_id+"  AND `markAsDel`=0";
					if(buju.currentRS.isRiege())
						firstsql+=" AND riege="+riege

					var leistung_vollstaendig=false;
					var leistung_vollstaendig_cid=0;
					DBSYNC._selectSql(firstsql, "", function(elems){
						if(elems.length>0){
							leistung_vollstaendig=true;
							$.each(elems, function(key,data){
								leistung_vollstaendig_cid=data.cid;								
							})							
						}	

						sql = "SELECT teilnehmerlisten_v_schueler.tnl_v_schueler_id, teilnehmerlisten_v_schueler.schueler_id, teilnehmerlisten_v_schueler.name, teilnehmerlisten_v_schueler.vorname, teilnehmerlisten_v_schueler.geschlecht, teilnehmerlisten_v_schueler.altera, teilnehmerlisten_v_schueler.riege, uebauswahl.uebungs_id, uebungen.bezeichnung, uebungen.eingabe_typ, teilnehmerlisten_v_schueler.klasse, uebungen.eingabe_format, eingabeformate.format, uebungen.beurteilung, uebungen.rekord_m, uebungen.rekord_w, handicap_startklassen.startklasse AS startklasse_txt, uebauswahl.alternative, teilnehmerlisten_v_schueler.startklasse, handicap_faktor_flach.faktor, leistungen.leistung, leistungen.clid AS leistungs_id, uebauswahl.uebauswahl_id, eingabeformate.formatID FROM (((((teilnehmerlisten_v_schueler LEFT JOIN handicap_startklassen ON teilnehmerlisten_v_schueler.startklasse=handicap_startklassen.startklasse_id) LEFT JOIN uebauswahl ON teilnehmerlisten_v_schueler.tnl_v_schueler_id = uebauswahl.tnl_v_schueler_id) LEFT JOIN uebungen ON uebauswahl.uebungs_id = uebungen.uebungs_id) LEFT JOIN eingabeformate ON uebungen.eingabe_format=eingabeformate.formatID) LEFT JOIN handicap_faktor_flach ON teilnehmerlisten_v_schueler.startklasse=handicap_faktor_flach.startklasse AND teilnehmerlisten_v_schueler.geschlecht=handicap_faktor_flach.geschlecht) LEFT JOIN leistungen ON teilnehmerlisten_v_schueler.tnl_v_schueler_id=leistungen.tnl_v_schueler_id AND uebauswahl.uebauswahl_id=leistungen.uebauswahl_id WHERE (((teilnehmerlisten_v_schueler.tnl_id)="+tnl_id+") AND ((uebauswahl.disziplin_id)="+disziplin_id+")"
						if(buju.currentRS.isRiege()){
							sql += " AND ((teilnehmerlisten_v_schueler.riege)="+riege+")"
						}	
						sql += " AND (uebauswahl.uebungs_id=handicap_faktor_flach.uebungs_id OR (handicap_faktor_flach.uebungs_id) IS NULL)) ORDER BY 8,3,4"	
						
						var contentStr = new Array();					
						DBSYNC._selectSql(sql, "", function(elems){							
							contentStr.push("<h3>Leistungen eintragen</h3>");
							contentStr.push("<form data-ajax=\"false\" id=\"leistungen_eintragen\" onSubmit=\"return false;\">");							
							contentStr.push("<table id=\"tabelle_leistungen\" data-role=\"table\" class=\"ui-responsive table-stroke\">");
							//contentStr.push("<table data-role=\"table\" id=\"leistungen\" data-mode=\"reflow\" class=\"ui-responsive\">")
							contentStr.push("<thead>");
							contentStr.push("<tr>");							
							contentStr.push("<th>Klasse</th>");							
							contentStr.push("<th>Vorname</th>");						
							contentStr.push("<th>Name</th>");						
							contentStr.push("<th>Leistung</th>");
							contentStr.push("<th>Übung</th>");
							contentStr.push("<th>Startklasse</th>");						
							contentStr.push("</tr>");
							contentStr.push("</thead>");
							contentStr.push("<tbody>");
							var myindex=0;
							var mobiScrollElems = new Array(9);
							mobiScrollElems[0] = new Array();
							mobiScrollElems[1] = new Array();
							mobiScrollElems[2] = new Array();
							mobiScrollElems[3] = new Array();
							mobiScrollElems[4] = new Array();
							mobiScrollElems[5] = new Array();
							mobiScrollElems[6] = new Array();
							mobiScrollElems[7] = new Array();
							mobiScrollElems[8] = new Array();
							
							$.each(elems, function(key,data){
								contentStr.push("<tr>");						
								contentStr.push("<td>"+data.klasse+"</td>");
								contentStr.push("<td>")								
								if (data.vorname)							
									contentStr.push(data.vorname);							
								contentStr.push("</td>");	
								contentStr.push("<td>")								
								if (data.name)							
									contentStr.push(data.name);							
								contentStr.push("</td>");	
																				
								contentStr.push("<td id=\"myrow"+myindex+"\">");
								contentStr.push("<div>")
								switch(data.eingabe_typ){
									case 0:
										contentStr.push("<label for=\"leistung_"+myindex+"_"+data.tnl_v_schueler_id+"\" class=\"hidden\">Eingabeformat "+data.format+"</label>");
										contentStr.push("<input type=\"text\" size=6 maxlength=6 name=\"leistung_"+data.tnl_v_schueler_id+"\" id=\"leistung_"+myindex+"_"+data.tnl_v_schueler_id+"\" value=\"");
										if(data.formatID)
											mobiScrollElems[data.formatID-1].push("#leistung_"+myindex+"_"+data.tnl_v_schueler_id);
										if(data.leistung){
											var leistung = data.leistung.toString();
											if(data.eingabe_format && data.eingabe_format==3){												
												//Komma mit Punkt ersetzen												
												leistung = leistung.replace(/,/g, '.');												
											}											
											contentStr.push(leistung);
										}							
										if(data.format)
											contentStr.push("\" placeholder=\"Eingabeformat "+data.format+"\"")							
										else
											contentStr.push("\" placeholder=\"\"")							
										if(data.leistungs_id)
											contentStr.push(" leistungs_id=\""+data.leistungs_id+"\"");
										else
											contentStr.push(" leistungs_id=\"-1\"")
										contentStr.push(" tnl_v_schueler_id=\""+data.tnl_v_schueler_id+"\" ");	
										contentStr.push(" uebungs_id=\""+data.uebungs_id+"\" ");	
										contentStr.push(" uebauswahl_id=\""+data.uebauswahl_id+"\" ");	
										contentStr.push(" myindex=\""+myindex+"\" ");	
										//Rekorde
										if((data.geschlecht==0 && data.rekord_w>0) || (data.geschlecht!=0 && data.rekord_m>0)){
											contentStr.push(" class=\"leistungen checkinput\"");
											contentStr.push(" rekord=\"");
											if(data.geschlecht==0)
												contentStr.push(data.rekord_w);
											else
												contentStr.push(data.rekord_m);
											contentStr.push("\" beurteilung=\"");
											contentStr.push(data.beurteilung);
											contentStr.push("\"");
											if(data.eingabe_format)
												contentStr.push(" onchange=\"check(this,"+data.eingabe_format+")\"");
											else
												contentStr.push(" onchange=\"check(this,-1);\"");												
										} else {
											contentStr.push(" class=\"leistungen\"");
										}										
										contentStr.push(">");
										break;										
									
									case 1:
										
										//checkbox
										contentStr.push("<label for=\"leistung_"+myindex+"_"+data.tnl_v_schueler_id+"\">Bestanden?</label>")
										if(data.leistung==1)							
											contentStr.push("<input type=\"checkbox\" data-role=\"flipswitch\" name=\"leistung_"+data.tnl_v_schueler_id+"\" class=\"leistungen\"  value=\"1\" checked id=\"leistung_"+myindex+"_"+data.tnl_v_schueler_id+"\"");
										else
											contentStr.push("<input type=\"checkbox\" data-role=\"flipswitch\" name=\"leistung_"+data.tnl_v_schueler_id+"\" class=\"leistungen\"  value=\"1\"  id=\"leistung_"+myindex+"_"+data.tnl_v_schueler_id+"\"");							
										if(data.leistungs_id)
											contentStr.push(" leistungs_id=\""+data.leistungs_id+"\"");
										else
											contentStr.push(" leistungs_id=\"-1\"")
										contentStr.push(" tnl_v_schueler_id=\""+data.tnl_v_schueler_id+"\" ");	
										contentStr.push(" uebungs_id=\""+data.uebungs_id+"\" ");	
										contentStr.push(" uebauswahl_id=\""+data.uebauswahl_id+"\" ");	
										contentStr.push(" data-on-text=\"ja\" data-off-text=\"nein\">");
																																			
										break;
								}
								
								contentStr.push("</div>");
								contentStr.push("<div id=\"warnung"+myindex+"\" class=\"eintrag_d_rekordwarnung\"></div>")
								contentStr.push("</td>");
								contentStr.push("<td>"+data.bezeichnung+"</td>");								
								contentStr.push("<td>");								
								if (data.startklasse_txt)
									contentStr.push(data.startklasse_txt);
								if (data.faktor){
									contentStr.push("</br>Faktor:");
									contentStr.push(data.faktor);
								}
																
								contentStr.push("</td>");							
								contentStr.push("</tr>");	
								myindex++;
							})
							contentStr.push("</tbody>");
							contentStr.push("</table>");
							contentStr.push("<label for=\"leistung_vollstaendig\">Eingabe vollständig</label>")
							if(leistung_vollstaendig)							
								contentStr.push("<input type=\"checkbox\" data-role=\"flipswitch\" name=\"leistung_vollstaendig\" checked id=\"leistung_vollstaendig\" data-on-text=\"ja\" data-off-text=\"nein\">");
							else
								contentStr.push("<input type=\"checkbox\" data-role=\"flipswitch\" name=\"leistung_vollstaendig\" id=\"leistung_vollstaendig\" data-on-text=\"ja\" data-off-text=\"nein\">");							
							contentStr.push("<button class=\"ui-btn\" id=\"btnLeistungEintragen\">Leistungen eintragen</button>");
							contentStr.push("</form>");
							$("#workinputcontent",$.mobile.activePage).html(contentStr.join("")).trigger('create');
							
							
							//mobiscroll vielleicht hier
							if (mobiScrollElems.length>0){
								for (k=0; k<mobiScrollElems.length; k++){
									if(mobiScrollElems[k].length>0){
										switch(k){
											case 0:
												//format s,0
												//Stimmt noch nicht, müssten sekunden/hunderstelsekunden werden
												$(mobiScrollElems[k].join(", ")).mobiscroll().timespan({
													theme: 'mobiscroll',
													display: 'bottom',
													mode: 'scroller',
													wheelOrder: 'ssuu',
													lang: 'de',
													labels: ['Jahre', 'Monate', 'Tage', 'Stunden', 'Minuten', 'Sekunden','Hundertstel'],
													formatResult: function (data) {										
														if (data[1]<10)
															return data[0] + ',0' + data[1];
														else
															return data[0] + ',' + data[1];
													},
													parseValue: function (val) {
														if (val) {
															if(val.indexOf(',')>0){
																val = val.toString().split(',');
																if (val[1].length==1)
																	val[1]=val[1]*10;
																return [parseInt(val[0]), parseInt(val[1])];
															}
															if(val.indexOf('.')>0){
																val = val.toString().split('.');
																if (val[1].length==1)
																	val[1]=val[1]*10;
																return [parseInt(val[0]), parseInt(val[1])];															
															}
															return [parseInt(val), 0];
														}
														return [0, 0]; // Default value if input is empty
													}									
												}); 																			
												break;
											
											case 1:
												//format m,cm
												$(mobiScrollElems[k].join(", ")).mobiscroll().distance({
													theme: 'mobiscroll',
													display: 'bottom',
													defUnit: 'm',
													units: ['m'],
													step: 0.01,
													lang: 'de',
													formatResult: function (data) {										
														if (data[1]<10)
															return data[0] + ',0' + data[1];
														else
															return data[0] + ',' + data[1];
													},
													parseValue: function (val) {
														if (val) {
															val = val.toString().split(',');
															return [val[0], val[1]];
														}
														return [0, 0]; // Default value if input is empty
													}																																		
												})
												break;
											
											case 2:
												//format m.ss
												$(mobiScrollElems[k].join(", ")).mobiscroll().timespan({
													theme: 'mobiscroll',
													display: 'bottom',
													mode: 'scroller',
													wheelOrder: 'iiss',
													lang: 'de',
													labels: ['Jahre', 'Monate', 'Tage', 'Stunden', 'Minuten', 'Sekunden','Hundertstel'],
													formatResult: function (data) {										
														if(data[1]<10)
															return data[0] + '.0' + data[1];
														else
															return data[0] + '.' + data[1];
													},
													parseValue: function (val) {														
														if (val) {
															if(val.indexOf(',')>0){
																val = val.toString().split(',');
																if (val[1].length==1)
																	val[1]=val[1]*10;
																return [parseInt(val[0]), parseInt(val[1])];															
															}															
															if(val.indexOf('.')>0){
																val = val.toString().split('.');
																if (val[1].length==1)
																	val[1]=val[1]*10;
																return [parseInt(val[0]), parseInt(val[1])];															
															}
															return [parseInt(val), 0];
														
														}
														return [0, 0]; // Default value if input is empty
													}									
												}); 																			
												break;
											
											case 3:
												//format Meter
												$(mobiScrollElems[k].join(", ")).mobiscroll().distance({
													lang: 'de',
													display: 'bottom',
													defUnit: 'm',
													units: ['m'],
													step: 1,
													formatResult: function (data) {										
														return data[0];
													}													
												})
												break;

											
											case 4:
												//m,cm (auf 1/2m)
												//format m,cm
												$(mobiScrollElems[k].join(", ")).mobiscroll().distance({
													theme: 'mobiscroll',
													display: 'bottom',
													defUnit: 'm',
													units: ['m'],
													step: 0.5,
													lang: 'de',
													formatResult: function (data) {										
														return data[0] + ',' + data[1];
													},
													parseValue: function (val) {
														if (val) {
															val = val.toString().split(',');
															return [val[0], val[1]];
														}
														return [0, 0]; // Default value if input is empty
													}																																		
												})
												break;	

											//zusaetzliche Eingabeformate Wettbewerb/Turnen usw. wg. Mobiscroll!
											case 5:
												// Punkte (ganze Punkte)
												$(mobiScrollElems[k].join(", ")).mobiscroll().number({
													theme: 'mobiscroll',
													display: 'bottom',
													mode: 'scroller',
													step: 1,
													wholeText: 'Punkte',
													lang: 'de',
													showLabel: true
												});																						
												break;
												
											case 6:
												// Punkte (ganze/halbe Punkte)
												$(mobiScrollElems[k].join(", ")).mobiscroll().number({
													theme: 'mobiscroll',
													display: 'bottom',
													mode: 'scroller',
													step: 0.5,
													wholeText: 'Punkte',
													fractionText: 'Halbe',
													lang: 'de',
													formatResult: function (data) {										
														return data[0] + '.' + data[1];
													},
													showLabel: true													
												});														
												break;

												
											case 7:
												// Ganze Sekunden (Differenz)
												$(mobiScrollElems[k].join(", ")).mobiscroll().number({
													theme: 'mobiscroll',
													display: 'bottom',
													mode: 'scroller',
													step: 1,
													wholeText: 'Sekunden',
													lang: 'de'													
												});														
												break;
												
											case 8:
												// (m,cm) (auch Negativ)
												// !!!NEGATIV FEHLT NOCH!!!
												$(mobiScrollElems[k].join(", ")).mobiscroll().temperature({
													theme: 'mobiscroll',
													display: 'bottom',
													defUnit: 'c',
													units: ['c'],												
													convert: false,
													unitNames: { c: 'm', k: '', f: '', r: '' },
													step: 0.01,
													lang: 'de',
													formatResult: function (data) {										
														if(data[0]=="-"){
															if (data[2]<10)
																return data[0] + data[1] + ',0' + data[2];
															else
																return data[0] + data[1] + ',' + data[2];														
														} else {
															if (data[2]<10)
																return data[1] + ',0' + data[2];
															else
																return data[1] + ',' + data[2]														
														}
													}													
												});
												
												
												/*
												$(mobiScrollElems[k].join(", ")).mobiscroll().distance({
													theme: 'mobiscroll',
													display: 'bottom',
													defUnit: 'm',
													units: ['m'],
													step: 0.01,
													lang: 'de',
													formatResult: function (data) {										
														if(data[1]<10)
															return data[0] + ',0' + data[1];
														else
															return data[0] + ',' + data[1];
													},
													parseValue: function (val) {
														if (val) {
															val = val.toString().split(',');
															return [val[0], val[1]];
														}
														return [0, 0]; // Default value if input is empty
													}																							
												})
												*/
												break;

										}
									}
								}
							
							}
							
							$("#leistungen_eintragen input.leistungen").change(function(elem){
								//nur editierte Leistungen abspeichern
								$(this).attr("changed","1");								
							})
							
							$("#btnLeistungEintragen").click(function(event){															
								$.mobile.loading( "show" );
								var msgStr="";
								var updateSql = new Array();
								$("#leistungen_eintragen input.leistungen[type=checkbox]").each(function(elem){
									if($(this).is(":checked"))
										$(this).val(1);
									else
										$(this).val(0);
								})
								
								$("#leistungen_eintragen input.leistungen").each(function(elem){									
									if($(this).attr("changed")=="1"){
										var leistungs_id = $(this).attr("leistungs_id");
										var sql="";
										msgStr+="Leistung "+$(this).val() +" | leistungs_id "+leistungs_id+"\n";
										
										if (leistungs_id!="-1"){
											DBSYNC._executeSql("UPDATE leistungen SET leistung='"+$(this).val()+"' WHERE clid="+leistungs_id,[]);										
										} else {											
											DBSYNC._executeSql("INSERT INTO leistungen (lid,tnl_v_schueler_id, uebungs_id, leistung, punkte, uebauswahl_id) VALUES (?,?,?,?,?,?)", [-1,$(this).attr("tnl_v_schueler_id"),$(this).attr("uebungs_id"),$(this).val(),0,$(this).attr("uebauswahl_id")]);
										}		

									}
								})
								if($("#leistung_vollstaendig").is(':checked')){									
									if (leistung_vollstaendig_cid==0){
										//einfügen in leistungen vollstaendig
										if(buju.currentRS.isRiege())
											DBSYNC._executeSql("INSERT INTO leistungen_vollstaendig (id, tnl_id, riege, disziplin_id, markAsDel) VALUES (?,?,?,?,?)", [-1, tnl_id, riege, disziplin_id,0]);
										else
											DBSYNC._executeSql("INSERT INTO leistungen_vollstaendig (id, tnl_id, riege, disziplin_id, markAsDel) VALUES (?,?,?,?,?)", [-1, tnl_id, 0, disziplin_id,0]);										
									}									
								} else {
									if (leistung_vollstaendig_cid>0){
										//löschen (wie auch immer, eigentlich markieren oder merken als geloescht!)
										//DBSYNC._executeSql("DELETE FROM leistungen_vollstaendig WHERE cid="+leistung_vollstaendig_cid,[]);
										DBSYNC._executeSql("UPDATE `leistungen_vollstaendig` SET `markAsDel`=1 WHERE `cid`="+leistung_vollstaendig_cid,[]);
									}									
								}								
								$.mobile.loading( "hide" );
								$.mobile.back();
							})
						})																						
					})											
				})
			})
			
			.on('pageshow', '#helpPage', function(){
			
			})

			
			
			.on('pageshow', '#impress', function(){				
				$("#enableDebug").click(function(){					
					$("li#debugMenu").prev().removeClass("ui-last-child");
					$("li#debugMenu").removeClass("ui-screen-hidden").addClass("ui-last-child");					
				})				
			})
			
			
			.on('pageshow', '#debug', function(){			
				if(buju.debugConsoleDataEnable){
					$("#consoleLogEnable").prop('checked', true).flipswitch('refresh');
				}
			
				$("#sendData").change(function(){
					if($(this).is(":checked")){
						$("#debugBtn").removeClass("ui-disabled");
					} else {
						$("#debugBtn").addClass("ui-disabled");
					}
				})
				
				$("#consoleLogEnable").change(function(){
					if($(this).is(":checked")){
						buju.debugConsoleDataEnable = true;
					} else {
						buju.debugConsoleDataEnable = false;
					}
				})
				
			
				$("#debugBtn").click(function(event){										
					event.preventDefault();
					buju.dumpData();									
				})
			})
	},
	doSync: function(){
		buju.useDB(function(){			
			DBSYNC.syncNow(buju.callBackSyncProgress, function(){								
				buju.debugInfo("callback syncNow");
				//quick´n´dirty solution...
				DBSYNC._executeSql("DELETE FROM leistungen WHERE lid=-1",[]);
				DBSYNC._executeSql("DELETE FROM leistungen_vollstaendig WHERE id=-1",[]);
				//hier könnten auch die Löschweitergaben gehandhabt werden				
				DBSYNC._executeSql("DELETE FROM leistungen WHERE lid IN (SELECT lid FROM delete_leistungen)",[]);
				DBSYNC._executeSql("DELETE FROM leistungen_vollstaendig WHERE id IN (SELECT lv_id FROM delete_leistungen_vollstaendig)",[]);
				DBSYNC._executeSql("DELETE FROM teilnehmerlisten WHERE tnl_id IN (SELECT tnl_id FROM delete_teilnehmerlisten)",[]);
				DBSYNC._executeSql("DELETE FROM teilnehmerlisten_v_schueler WHERE tnl_v_schueler_id IN (SELECT tnl_v_schueler_id FROM delete_teilnehmerlisten_v_schueler)",[]);
				DBSYNC._executeSql("DELETE FROM uebauswahl WHERE uebauswahl_id IN (SELECT uebauswahl_id FROM delete_uebauswahl)",[]);
				DBSYNC._executeSql("DELETE FROM veranstaltungen WHERE id IN (SELECT veranstaltungs_id FROM delete_veranstaltungen)",[]);
				
				DBSYNC._executeSql("DELETE FROM delete_leistungen",[]);
				DBSYNC._executeSql("DELETE FROM delete_leistungen_vollstaendig",[]);
				DBSYNC._executeSql("DELETE FROM delete_teilnehmerlisten",[]);
				DBSYNC._executeSql("DELETE FROM delete_teilnehmerlisten_v_schueler",[]);
				DBSYNC._executeSql("DELETE FROM delete_uebauswahl",[]);
				DBSYNC._executeSql("DELETE FROM delete_veranstaltungen",[]);
				buju.debugInfo("callback syncNow DataReorganisationDone");
			});
		});
	},
	useDB: function(callback){
		if(!BUJUSYNCDATA.database)
			BUJUSYNCDATA.initTestDb(function(){				
				DBSYNC.initSync(BUJUSYNCDATA.tableToSync, BUJUSYNCDATA.database, BUJUSYNCDATA.sync_info, BUJUSYNCDATA.url, function(firstSync){
					callback();
				})				
			});
		else
			callback();
	},
	showAlert: function (message, title) {
		if (navigator.notification) {
			navigator.notification.alert(message, null, title, 'OK');
		} else {
			alert(title ? (title + ": " + message) : message);
		}
	},	
	callBackSyncProgress: function(message, percent, msgKey){	    
         $('#syncProgress',$.mobile.activePage).html(message);
		 //$('.pie_progress',$.mobile.activePage).asPieProgress('go',percent);	
		chart.update(percent);		 
    },
	debugInfo: function(str){	
		if (buju.debugConsoleDataEnable==true){
			buju.debugConsoleData.push(str);
		}
	
		console.log(str);
	},
	dumpData: function(){
		buju.useDB(function(){			
			$.when(
				buju.dumpTableData("leistungen"), 
				buju.dumpTableData("leistungen_vollstaendig")
			).then(function(leistungen, leistungen_vollstaendig) {	
				$.mobile.loading( "show" );				
				var adata = {leistungen:leistungen, leistungen_vollstaendig:leistungen_vollstaendig};
				
				//Convert to JSON				
				var serializedData = JSON.stringify(adata);						
				var serializedDebugData = JSON.stringify(buju.debugConsoleData);
				var postdata = new Array()
				postdata.push({ 'name': 'aktion', 'value':'doDebug'});
				postdata.push({ 'name': 'login', 'value': buju.userLogin});
				postdata.push({ 'name': 'loginToken', 'value': buju.loginToken});
				postdata.push({ 'name': 'userEmail', 'value': buju.userEmail});
				postdata.push({ 'name': 'desc', 'value': $("#desc").val()});
				postdata.push({ 'name': 'db_data', 'value': serializedData});			
				postdata.push({ 'name': 'console', 'value': serializedDebugData});			
												
				$.post(buju.serviceUrl, postdata, function(data){				
					$("#supportform").hide(200);
					$("#debugResult").html(data);					
					$.mobile.loading( "hide" );
				},"text");			
			});
		})
	},
	dumpTableData: function(table){		
		var def = new $.Deferred();
		BUJUSYNCDATA.database.readTransaction(function(tx) {
			tx.executeSql("select * from "+table, [], function(tx,results) {
				var data = Util.convertResults(results, table);				
				//console.dir(data);				
				def.resolve(data);				
			});
		}, BUJUSYNCDATA._errorHandler);				
		return def;					
	}
}

/*teile aus buju anwendung... eingabe auf rekorde überprüfen usw.*/
function check(obj,eingabe_format_id){
	checkinput(obj,eingabe_format_id);
}

function checkinput(obj,eingabe_format_id){	
	if(eingabe_format_id==1){
		//Leichtathletik Sprint, 1 Nachkommastelle
		input_wert = makeFloat(obj.value);
		input_wert_str = input_wert.toFixed(1).toString();
		input_wert_str = input_wert_str.replace(/\./,",");
		obj.value = input_wert_str;
	}
	
	if(eingabe_format_id==5){
		//Ballwurf 80g/200g, auf halbe m gerundet
		input_wert = makeFloat(obj.value);
		input_wert_ganzzahl = Math.floor(input_wert);
		input_wert_gesamt = input_wert.toPrecision(2);
		if(input_wert_gesamt-input_wert_ganzzahl>=0.5){
			input_wert = input_wert_ganzzahl + 0.5;
		} else {
			input_wert = input_wert_ganzzahl;
		}
		input_wert_str = input_wert.toFixed(1).toString();
		input_wert_str = input_wert_str.replace(/\./,",");
		obj.value = input_wert_str;
	}
	
	if(obj.getAttribute("rekord")){
		if(obj.getAttribute("rekord")!="" && obj.getAttribute("rekord")!="0"){
			//Rekord Existiert
			rekord_wert = makeFloat(obj.getAttribute("rekord"));		
			input_wert = makeFloat(obj.value);
			beurteilung = obj.getAttribute("beurteilung");
					
			if((beurteilung=="1" && input_wert>=rekord_wert) || (beurteilung=="-1" && input_wert<=rekord_wert)){
				$("#warnung"+obj.getAttribute("myindex")).html("REKORD !!!");	
				$("#myrow"+obj.getAttribute("myindex")).addClass("rekord");
				return false;
			} else {
				$("#warnung"+obj.getAttribute("myindex")).html("");
				$("#myrow"+obj.getAttribute("myindex")).removeClass("rekord");
				return true;
			}				
		}		
		return true;
	} 
	return true;
}

function makeFloat(value){
	if(value!=""){
		value = value.replace(/,/,".");		
		if (!isNaN(parseFloat(value))){
			return parseFloat(value);
		} else { 
			return 0.0;
		}
	} else {
		return 0.0
	}
}