document.addEventListener("deviceready", onDeviceReady, false);
function onDeviceReady() {
	BUJUSYNCDATA.updateSyncInfo();
}
			
			
var BUJUSYNCDATA = {
    url: buju.serviceUrl, //TODO Set your server URL
    database: null,
    tableToSync: [
		{
			tableName: 'veranstaltungen',
			idName: 'id'    
		},
		{
			tableName: 'teilnehmerlisten',
			idName: 'tnl_id'    
		},
		{
			tableName: 'disziplinen',
			idName: 'disziplin_id'    
		},
		{
			tableName: 'sportarten',
			idName: 'sportart_id'    
		},		
		{
			tableName: 'teilnehmerlisten_v_schueler',
			idName: 'tnl_v_schueler_id'    
		},
		{
			tableName: 'uebauswahl',
			idName: 'uebauswahl_id'    
		},
		{
			tableName: 'uebungen',
			idName: 'uebungs_id'    
		},
		{
			tableName: 'veranstaltungstypen',
			idName: 'veranstaltungstyp_id'    
		},
		{
			tableName: 'eingabeformate',
			idName: 'formatID'    
		},
		{
			tableName: 'leistungen',
			idName: 'lid'    
		},
		{
			tableName: 'leistungen_vollstaendig',
			idName: 'id'    
		},
		{
			tableName: 'handicap_faktor_flach',
			idName: 'handicap_faktor_flach_id'
		},
		{
			tableName: 'handicap_startklassen',
			idName: 'startklasse_id'
		},
		{
			tableName: 'delete_leistungen',
			idName: 'id'
		},
		{
			tableName: 'delete_leistungen_vollstaendig',
			idName: 'id'
		},
		{
			tableName: 'delete_teilnehmerlisten',
			idName: 'id'
		},
		{
			tableName: 'delete_teilnehmerlisten_v_schueler',
			idName: 'id'
		},
		{
			tableName: 'delete_uebauswahl',
			idName: 'id'
		},
		{
			tableName: 'delete_veranstaltungen',
			idName: 'id'
		}
	],
    sync_info: {//Example of user info
        user_id: buju.userId,
		userEmail: buju.userEmail,//the user mail is not always here		
		loginToken: buju.loginToken,        		
        lastSyncDate: 0,			
		device_uuid: fakedevice.uuid, //if no user mail, rely on the UUID
		device_version: fakedevice.version,
        device_name: device.name,
		userAgent: navigator.userAgent,
        //app data
        appName: 'bujuSync',
        mosa_version: '1.0',
        lng: 'de'
    },
	updateSyncInfo: function(){
		this.sync_info.device_uuid = fakedevice.uuid;
		this.sync_info.device_version = fakedevice.version;
		this.sync_info.device_name = device.name;
		this.sync_info.userId = buju.userId;
		this.sync_info.userEmail = buju.userEmail;
		this.sync_info.loginToken = buju.loginToken;
	},
	clearDb: function(callBack){
        this.database.transaction(function(transaction){
            transaction.name = 'initTestDb general tx';
            //drop the table (will drop automatically the triggers)

			var createSql = new Array();
            createSql[0] = 'DROP TABLE veranstaltungen';			
			createSql[1] = 'DROP TABLE "teilnehmerlisten"';						
			createSql[2] = 'DROP TABLE "disziplinen"';
			createSql[3] = 'DROP TABLE "sportarten"';						
			createSql[4] = 'DROP TABLE "teilnehmerlisten_v_schueler"';			
			createSql[5] = 'DROP TABLE "uebauswahl"';					  
			createSql[6] = 'DROP TABLE "uebungen"';			
			createSql[7] = 'DROP TABLE "veranstaltungstypen"';  
			createSql[8] = 'DROP TABLE "eingabeformate"';
			createSql[9] = 'DROP TABLE "leistungen"';	  	
			createSql[10] = 'DROP TABLE "leistungen_vollstaendig"';		
			createSql[11] = 'DROP TABLE "handicap_faktor_flach"';  			
			createSql[12] = 'DROP TABLE "handicap_startklassen"';
			  			
			for(k=0; k<createSql.length; k++){
				if(k==createSql.length-1){
					if(createSql[k]!="")
						transaction.executeSql(createSql[k], [], callBack);				
				} else {
					if(createSql[k]!="")
						transaction.executeSql(createSql[k], [], self._nullDataHandler, self._errorHandler);                                                 				
				}
			}            			
        });//end tx	
	},
    initTestDb: function(callBack){
        var self = this;
        if (self.database === null) {
            self.database = openDatabase('bujuClient', '1.0', 'bujuClient DB Sync', 4 * 1024 * 1024);
            
			//geht leider nicht...
			//self.database = openDatabaseSync('bujuClient', '1.0', 'bujuClient DB Sync', 4 * 1024 * 1024);
        }
        this.database.transaction(function(transaction){
            transaction.name = 'initTestDb general tx';
            //drop the table (will drop automatically the triggers)

			var createSql = new Array();
            createSql[0] = 'CREATE TABLE IF NOT EXISTS veranstaltungen (' +
            'id int(11) NOT NULL ,'+            
            'lehrer_id int(11) DEFAULT 0,'+
            'veranstaltungstyp int(11) DEFAULT 0,'+         
            'sportart int(11) DEFAULT 0,'+          
            'titel varchar(150) DEFAULT NULL,'+     
            'ts timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,'+         
            'PRIMARY KEY (id))';
			
			createSql[1] = 'CREATE TABLE IF NOT EXISTS "teilnehmerlisten" (' +
			'"tnl_id" int(11) NOT NULL,' +
			'"veranstaltungs_id" int(11) DEFAULT 0,' +
			'"bezeichnung" varchar(150) DEFAULT NULL,' +
			'"leiter" varchar(50) DEFAULT NULL,' +
			'"ts" timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,' +
			'"riege" tinyint(1) DEFAULT 0,' +
			'"ansicht_kurz" varchar(50) DEFAULT NULL,' +
			'"ansicht_where_str" varchar(255) DEFAULT NULL,' +
			'"ansicht_orderby_str" varchar(200) DEFAULT NULL,' +
			'"ohne_riegeneinteilung" tinyint(1)  NOT NULL,' +
			'PRIMARY KEY ("tnl_id"))';			
			
			createSql[2] = 'CREATE TABLE IF NOT EXISTS "disziplinen" (' +
			'"disziplin_id" int(11) NOT NULL ,' +
			'"veranstaltungstyp_id" int(11) DEFAULT 0,'+
			'"sportart_id" int(11) DEFAULT 0,'+
			'"disziplin" varchar(50) DEFAULT NULL,' +
			'"wk_versuche" int(11) DEFAULT 0,' +
			'"wk_label" varchar(50) DEFAULT NULL,' +
			'PRIMARY KEY ("disziplin_id"))';

			createSql[3] = 'CREATE TABLE IF NOT EXISTS "sportarten" (' +
			'"sportart_id" int(11) NOT NULL ,' +
			'"sportart" varchar(50) DEFAULT NULL,' +
			'PRIMARY KEY ("sportart_id"))';
						
			createSql[4] = 'CREATE TABLE IF NOT EXISTS "teilnehmerlisten_v_schueler" (' +
			'"tnl_v_schueler_id" int(11) NOT NULL ,' +
			'"tnl_id" int(11) DEFAULT 0,' +
			'"schueler_id" int(11) DEFAULT 0,' +
			'"name" varchar(100) DEFAULT NULL,' +
			'"vorname" varchar(100) DEFAULT NULL,' +
			'"klasse" varchar(15) DEFAULT NULL,' +
			'"jahrgang" int(11) DEFAULT 0,' +
			'"geschlecht" tinyint(1) DEFAULT 0,' +
			'"startklasse" int(11) DEFAULT 0,' +
			'"ts" timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,' +
			'"riege" int(11) DEFAULT 0,' +
			'"altera" int(11) DEFAULT 0,' +
			'"punkte" int(11) DEFAULT 0,' +
			'"uk_tn" tinyint(1) DEFAULT 0,' +
			'"uk_su" tinyint(1) DEFAULT 0,' +
			'"uk_eu" tinyint(1) DEFAULT 0,' +
			'PRIMARY KEY ("tnl_v_schueler_id"))'; 			
			
			createSql[5] = 'CREATE TABLE IF NOT EXISTS  "uebauswahl" (' +
			'"uebauswahl_id" int(11) NOT NULL ,' +
			'"tnl_id" int(11) DEFAULT 0,' +
			'"tnl_v_schueler_id" int(11) DEFAULT 0,' + 
			'"disziplin_id" int(11) DEFAULT 0,' + 			
			'"uebungs_id" int(11) DEFAULT 0,' +
			'"alternative" tinyint(1) DEFAULT 0,' +
			'PRIMARY KEY ("uebauswahl_id"))';					
  
			createSql[6] = 'CREATE TABLE IF NOT EXISTS  "uebungen" (' +
			'"uebungs_id" int(11) NOT NULL ,' +
			'"sportart_id" int(11) DEFAULT 0,' +
			'"disziplin_id" int(11) DEFAULT 0,' +
			'"bezeichnung" varchar(150) DEFAULT NULL,' +
			'"m_von_alter" int(11) DEFAULT 0,' +
			'"m_bis_alter" int(11) DEFAULT 0,' +
			'"w_von_alter" int(11) DEFAULT 0,' +
			'"w_bis_alter" int(11) DEFAULT 0,' +
			'"beurteilung" int(11) DEFAULT 0,' +
			'"pdf" varchar(50) DEFAULT NULL,' +
			'"wk_versuche2" int(11) DEFAULT 0,' +
			'"eingabe_typ" int(11) DEFAULT 0,' +
			'"eingabe_format" int(11) DEFAULT 0,' +
			'"rekord_m" float DEFAULT 0,' +
			'"rekord_w" float DEFAULT 0,' +
			'PRIMARY KEY ("uebungs_id"))';
			
			createSql[7] = 'CREATE TABLE IF NOT EXISTS  "veranstaltungstypen" (' +
			'"veranstaltungstyp_id" int(11) NOT NULL ,' +
			'"veranstaltungstyp" varchar(50) DEFAULT NULL,' +
			'"select_sportart" tinyint(1) DEFAULT 0,' +
			'PRIMARY KEY ("veranstaltungstyp_id"))';
  
			createSql[8] = 'CREATE TABLE IF NOT EXISTS  "eingabeformate" (' +
			'"formatID" int(11) NOT NULL ,' +
			'"format" varchar(50) DEFAULT NULL,' +
			'PRIMARY KEY ("formatID"))';

/*			createSql[9] = 'CREATE TABLE IF NOT EXISTS "leistungen" (' +
			'"lid" int(11) NOT NULL ,' +
			'"tnl_v_schueler_id" int(11) DEFAULT 0,' +
			'"uebungs_id" int(11) DEFAULT 0,' +
			'"leistung" varchar(50) DEFAULT NULL,' +
			'"punkte" int(11) DEFAULT 0,' +
			'"timestamp" timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,' +
			'"uebauswahl_id" int(11) DEFAULT 0,' +
			'PRIMARY KEY ("lid"))';*/
  
			//NEU 10.11.2014
			createSql[9] = 'CREATE TABLE IF NOT EXISTS "leistungen" (' +
			'"clid" INTEGER PRIMARY KEY AUTOINCREMENT, ' +
			'"lid" int(11) NOT NULL ,' +
			'"tnl_v_schueler_id" int(11) DEFAULT 0,' +
			'"uebungs_id" int(11) DEFAULT 0,' +
			'"leistung" varchar(50) DEFAULT NULL,' +
			'"punkte" int(11) DEFAULT 0,' +
			'"timestamp" timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,' +
			'"uebauswahl_id" int(11) DEFAULT 0,' +
			'"lastsync" int(11) DEFAULT 0)';			
  
			/*
			createSql[10] =  'CREATE TABLE IF NOT EXISTS "leistungen_vollstaendig" (' +
			'"id" int(11) NOT NULL ,' +
			'"tnl_id" int(11) DEFAULT 0,' +
			'"riege" int(11) DEFAULT 0,' +
			'"disziplin_id" int(11) DEFAULT 0,' +
			'PRIMARY KEY ("id"))';
			*/
			
			//NEU 10.11.2014
			createSql[10] =  'CREATE TABLE IF NOT EXISTS "leistungen_vollstaendig" (' +
			'"cid" INTEGER PRIMARY KEY AUTOINCREMENT, ' +
			'"id" int(11) NOT NULL ,' +
			'"tnl_id" int(11) DEFAULT 0,' +
			'"riege" int(11) DEFAULT 0,' +
			'"disziplin_id" int(11) DEFAULT 0,' +
			'"markAsDel" tinyint(1) DEFAULT 0,' +
			'"lastsync" int(11) DEFAULT 0)';
			
			//neu 05.11.2014
			createSql[11] = 'CREATE TABLE IF NOT EXISTS "handicap_faktor_flach" (' +
			'"handicap_faktor_flach_id" int(11) NOT NULL ,' +
			'"uebungs_id" int(11) DEFAULT 0,' +
			'"geschlecht" tinyint(1) DEFAULT 0,' +
			'"startklasse" int(11) DEFAULT 0,' +
			'"faktor" float NOT NULL DEFAULT 0,' +
			'PRIMARY KEY ("handicap_faktor_flach_id"))';
  			
			createSql[12] = 'CREATE TABLE IF NOT EXISTS "handicap_startklassen" (' +
			'"startklasse_id" int(11) NOT NULL,' +
			'"master" int(11) DEFAULT 0,' +
			'"startklasse" varchar(50) DEFAULT NULL,' +
			'"text_kurz" varchar(150) DEFAULT NULL,' +
			'"text_lang" longtext,' +
			'"reihenfolge" int(11) DEFAULT 0,' +
			'"aktiv" tinyint(1) DEFAULT 0,' +
			'PRIMARY KEY ("startklasse_id"));'
			
			//torsten 14.11.2014
			//delete_tabellen_ebenfalls_synchronisieren
			//grund: lschweitergabe
			createSql[13] = 'CREATE TABLE IF NOT EXISTS "delete_leistungen" (' +
			'"id" int(11) NOT NULL,' +
			'"lid" int(11) NOT NULL,' +
			'"tnl_v_schueler_id" int(11) NOT NULL,' +
			'"timestamp" int(11) NOT NULL);'
			
			createSql[14] = 'CREATE TABLE IF NOT EXISTS "delete_leistungen_vollstaendig" (' +
			'"id" int(11) NOT NULL,' +			
			'"lv_id" int(11) NOT NULL,' +
			'"timestamp" int(11) NOT NULL);'

			createSql[15] = 'CREATE TABLE IF NOT EXISTS "delete_teilnehmerlisten" (' +
			'"id" int(10) NOT NULL,' +
			'"tnl_id" int(10) NOT NULL,' +
			'"veranstaltungs_id" int(10) NOT NULL,' +
			'"timestamp" int(11) NOT NULL);'
			
			createSql[16] = 'CREATE TABLE IF NOT EXISTS "delete_teilnehmerlisten_v_schueler" (' +
			'"id" int(10) NOT NULL,' +
			'"tnl_v_schueler_id" int(10) NOT NULL,' +
			'"tnl_id" int(10) NOT NULL,' +
			'"schueler_id" int(10) NOT NULL,' +
			'"timestamp" int(11) NOT NULL);'

			createSql[17] = 'CREATE TABLE IF NOT EXISTS "delete_uebauswahl" (' +
			'"id" int(10) NOT NULL,' +
			'"uebauswahl_id" int(10) NOT NULL,' +
			'"tnl_id" int(10) NOT NULL,' +
			'"tnl_v_schueler_id" int(10) NOT NULL,' +
			'"timestamp" int(11) NOT NULL);'

			createSql[18] = 'CREATE TABLE IF NOT EXISTS "delete_veranstaltungen" (' +
			'"id" int(10) NOT NULL,' +
			'"veranstaltungs_id" int(10) NOT NULL,' +
			'"lehrer_id" int(10) NOT NULL,' +			
			'"timestamp" int(11) NOT NULL);'			
			
			  			
			for(k=0; k<createSql.length; k++){
				if(k==createSql.length-1){
					if(createSql[k]!="")
						transaction.executeSql(createSql[k], [], callBack);				
				} else {
					if(createSql[k]!="")
						transaction.executeSql(createSql[k], [], self._nullDataHandler, self._errorHandler);                                                 				
				}
			}            			
        });//end tx
    },
    _nullDataHandler: function(){

    },
    _errorHandler: function(transaction, error){
        console.error('Error : ' + error.message + ' (Code ' + error.code + ') Transaction.name = ' + transaction.name);
    },
    _updateData : function(callback) {
		var self = this;
		SYNCDATA.database.transaction(function(transaction){
		});
	}
}